两数之和
LeetCode1:
给定一个整数数组nums和一个整数目标值target,请你在该数组中找出和为目标值target的那两个整数,并返回它们的数组下标。
你可以假设每次输入只会对应一个答案,但是数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。
示例1:
输入:nums = [2,7,11,15],target = 9
输出:[0,1]
解释:因为nums[0] + nums[1] == 9,返回[0,1]
示例2:
输入:nums = [3,2,4],target = 6
输出:[1,2]
示例3:
输入:nums = [3,3],target = 6
输出:[0,1]
暴力求解
思路:
用两个for循环,第一层循环找第一个数,第二层循环就是第一个数与后面的数相加,是否等
于target,如果找到就返回他们的下标,如果没找到就继续寻找。
public static int[] twoSum(int nums[],int target){
int n = nums.length;
for (int i = 0; i < n; i++){
for (int j = i + 1; j < n; j++){
if (nums[i] + nums[j] == target){
return new int[]{i,j};
}
}
}
return new int[0];
}
哈希表求解
思路:
使用哈希表解法,比如2,7,11,15,目标值为9。先遍历,轮到2,然后用9 - 2 = 7,在哈希表里找,显然,哈希表中没有找到7,就把当前的数字2和索引以键值对形式存入到哈希表中,然后遍历7,用 9 - 7 = 2,在表找,可以找到数字2 ,返回即可。
public static int[] twoSum(int nums[],int target){
//创建一个map
Map<Integer,Integer> map = new HashMap<>();
//遍历
for (int i = 0; i < nums.length; i++){
if (map.containsKey(target - nums[i])){
return new int[]{map.get(target-nums[i]),i};
}
map.put(nums[i],i);
}
return new int[0];
}
三数之和
leetCode15:
给你一个整数数组nums,判断是否存在三元组 [nums[i],nums[j],nums[k]]满足 i != j ,i != k ,且j != k,同时还满足 nums[i]+nums[j]+nums[k] == 0。请返回所有和为0且不重复的三元组
示例1:
输入:nums = [-1,0,1,2,-1,4]
输出:[[-1,-1,2],[-1,0,1]]
解释:nums[0] + nums[1] +nums[2] = (-1) + 0 + 1 = 0.
nums[1] + nums[2] +nums[4] = 0 + 1 + (-1) = 0.
nums[0] + nums[3] +nums[4] = (-1) + 2 + (-1) = 0.
不同的三元组是[-1,0,1] 和 [-1,-1,2]
注意,输出的顺序和三元组的顺序并不重要。
示例2:
输入:nums = [0,1,1]
输出:[]
解释:唯一可能的三元组和不为0
示例3:
输入:nums = [0,0,0]
输出:[[0,0,0]]
解释:唯一可能的三元组和为0
思路:
排序+双指针
先将数组排序,固定最左边的指针first,双指针second,third分别设在数组(first+1,nums.length-1)两端,通过双指针交替向中间移动,记录nums[first] + nums[second] +nums[third] = 0 时的nums组合。
public static List<List<Integer>> threeSum(int nums[]){
Arrays.sort(nums);//从小到大排序
List<List<Integer>> ans = new ArrayList<List<Integer>>();
//枚举a
for (int first = 0; first < nums.length; first++){
//每次列出的数与上次不同
if (first > 0 && nums[first] == nums[first - 1]){
continue;
}
int third = nums.length - 1;
int target = -nums[first];
//枚举b
for (int second = first + 1; second < nums.length; second++){
//列出第二个数与上次不同
if (second > first + 1 && nums[second] == nums[second - 1]){
continue;
}
while(second < third && nums[second] + nums[third] > target){
third--;
}
if (second == third){
break;
}
if (nums[second] + nums[third] == target){
List<Integer> list = new ArrayList<Integer>();
list.add(nums[first]);
list.add(nums[second]);
list.add(nums[third]);
ans.add(list);
}
}
}
return ans;
}